﻿using UnityEngine;
using Verse;

namespace RealisticRoomsRewritten
{
    public class RealisticRoomsSettings : ModSettings
    {
        public float minSpaceRatherTight = 6.5f;
        public float minSpaceAverageSized = 16.5f;
        public float minSpaceSomewhatSpacious = 28.5f;
        public float minSpaceQuiteSpacious = 49.5f;
        public float minSpaceVerySpacious = 84.5f;
        public float minSpaceExtremelySpacious = 174.5f;

        public override void ExposeData()
        {
            Scribe_Values.Look(ref this.minSpaceRatherTight, "minSpaceRatherTight", 6.5f);
            Scribe_Values.Look(ref this.minSpaceAverageSized, "minSpaceAverageSized", 16.5f);
            Scribe_Values.Look(ref this.minSpaceSomewhatSpacious, "minSpaceAverageSized", 28.5f);
            Scribe_Values.Look(ref this.minSpaceQuiteSpacious, "minSpaceAverageSized", 49.5f);
            Scribe_Values.Look(ref this.minSpaceVerySpacious, "minSpaceAverageSized", 84.5f);
            Scribe_Values.Look(ref this.minSpaceExtremelySpacious, "minSpaceAverageSized", 174.5f);
            base.ExposeData();
        }

        //public override string ModIdentifier { get { return "RealisticRoomsRewritten"; } }
        //private SettingHandle<float> minSpaceRatherTight;
        //private SettingHandle<float> minSpaceAverageSized;
        //private SettingHandle<float> minSpaceSomewhatSpacious;
        //private SettingHandle<float> minSpaceQuiteSpacious;
        //private SettingHandle<float> minSpaceVerySpacious;
        //private SettingHandle<float> minSpaceExtremelySpacious;
        //public override void DefsLoaded()
        //{
        //    minSpaceRatherTight = Settings.GetHandle<float>("minSpaceRatherTight", "Rather Tight Min Space", "Value can be decimal, value must be greater than 0 and less than next tier", 6.5f);
        //    minSpaceAverageSized = Settings.GetHandle<float>("minSpaceAverageSized", "Average-Sized Min Space", "Value can be decimal, value must be greater than previous tier and less than next tier", 16.5f);
        //    minSpaceSomewhatSpacious = Settings.GetHandle<float>("minSpaceSomewhatSpacious", "Somewhat Spacious Min Space", "Value can be decimal, value must be greater than previous tier and less than next tier", 28.5f);
        //    minSpaceQuiteSpacious = Settings.GetHandle<float>("minSpaceQuiteSpacious", "Quite Spacious Min Space", "Value can be decimal, value must be greater than previous tier and less than next tier", 49.5f);
        //    minSpaceVerySpacious = Settings.GetHandle<float>("minSpaceVerySpacious", "Very Spacious Min Space", "Value can be decimal, value must be greater than previous tier and less than next tier", 84.5f);
        //    minSpaceExtremelySpacious = Settings.GetHandle<float>("minSpaceExtremelySpacious", "Extremely Spacious Min Space", "Value can be decimal, value must be greater than previous tier", 174.5f);
        //    ApplySettings();
        //    base.DefsLoaded();
        //}

        //public override void SettingsChanged()
        //{
        //    base.SettingsChanged();
        //    if (minSpaceRatherTight.Value > minSpaceAverageSized.Value || minSpaceRatherTight.Value < 0f) minSpaceRatherTight.Value = 6.5f;
        //    if (minSpaceAverageSized.Value > minSpaceSomewhatSpacious.Value || minSpaceAverageSized.Value < minSpaceRatherTight.Value) minSpaceAverageSized.Value = 16.5f;
        //    if (minSpaceSomewhatSpacious.Value > minSpaceQuiteSpacious.Value || minSpaceSomewhatSpacious.Value < minSpaceAverageSized.Value) minSpaceSomewhatSpacious.Value = 28.5f;
        //    if (minSpaceQuiteSpacious.Value > minSpaceVerySpacious.Value || minSpaceQuiteSpacious.Value < minSpaceSomewhatSpacious.Value) minSpaceQuiteSpacious.Value = 49.5f;
        //    if (minSpaceVerySpacious.Value > minSpaceExtremelySpacious.Value || minSpaceVerySpacious.Value < minSpaceQuiteSpacious.Value) minSpaceVerySpacious.Value = 84.5f;
        //    if (minSpaceExtremelySpacious.Value > 9999999999f || minSpaceExtremelySpacious < minSpaceVerySpacious.Value) minSpaceExtremelySpacious.Value = 174.5f;
        //    ApplySettings();
        //}

        //private void ApplySettings()
        //{
        //    var scoreStages = DefDatabase<RoomStatDef>.GetNamed("Space").scoreStages;
        //    foreach (var stage in scoreStages)
        //    {
        //        if (stage.label == "rather tight") { stage.minScore = minSpaceRatherTight.Value; }
        //        if (stage.label == "average-sized") { stage.minScore = minSpaceAverageSized.Value; }
        //        if (stage.label == "somewhat spacious") { stage.minScore = minSpaceSomewhatSpacious.Value; }
        //        if (stage.label == "quite spacious") { stage.minScore = minSpaceQuiteSpacious.Value; }
        //        if (stage.label == "very spacious") { stage.minScore = minSpaceVerySpacious.Value; }
        //        if (stage.label == "extremely spacious") { stage.minScore = minSpaceExtremelySpacious.Value; }
        //    }
        //}
    }
    public class RealisticRoomsMod : Mod
    {
        RealisticRoomsSettings settings;

        public RealisticRoomsMod(ModContentPack content) : base(content)
        {
            settings = GetSettings<RealisticRoomsSettings>();
        }

        public override string SettingsCategory() => "RealisticRoomsSettingsCategoryLabel".Translate();

        public override void DoSettingsWindowContents(Rect inRect)
        {
            Listing_Standard listingStandard = new Listing_Standard();
            listingStandard.Begin(inRect);
            string buffer = settings.minSpaceRatherTight.ToString();
            listingStandard.TextFieldNumeric<float>(ref settings.minSpaceRatherTight, ref buffer, 0f, settings.minSpaceAverageSized);
            base.DoSettingsWindowContents(inRect);
        }
    }
}